using System.Collections.Generic;
using NUnit.Framework;
using ServiceStack.Common.Tests.Models;

namespace ServiceStack.Text.Tests
{
	[TestFixture]
	public class DdnContentIngestTests
		: TestBase
	{
		[Test]
		public void Can_serialize_ReleaseSet()
		{
			const string dtoString = @"{BatchId:1b842f15293d4cfba8a25b4d8b10798b,BatchName:2000000916259,BatchSequence:2000000916259,BatchPath:transcoded-i:///universal/2000000916259,Partial:False,Release:{Delete:False,ExternalRef:00028946767825,ExternalUrn:urn:album:universal:00028946767825,SupplierKeyName:universal,Name:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,NameExVersion:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,ReleaseType:Album,LabelText:Decca Music Group Ltd.,ArtistText:""Orchestra [Orchestra]"",UpcEan:00028946767825,SetCount:1,TrackCount:23,DurationMs:3594000,ContinuousMix:False,ExplicitType:NotExplicit,ReleaseDate:2002-03-11,Copyright:2001 Decca Music Group Limited,Genres:[Soundtrack],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingman [Conductor]"",Role:Artist,ExternalRef:nickingmanconductor,ExternalUrn:urn:artist:universal:nickingmanconductor},{Name:""Nick Ingman [Conductor]"",Role:Conductor,ExternalRef:nickingmanconductor,ExternalUrn:urn:artist:universal:nickingmanconductor},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:deccamusicgroupltd,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickingmanconductor]},ExternalTrackUrns:{Partial:False,Items:[urn:track:universal:00028946767825/gbbbb2014301,urn:track:universal:00028946767825/gbbbb2014302,urn:track:universal:00028946767825/gbbbb2014303,urn:track:universal:00028946767825/gbbbb2014304,urn:track:universal:00028946767825/gbbbb2014305,urn:track:universal:00028946767825/gbbbb2014306,urn:track:universal:00028946767825/gbbbb2014307,urn:track:universal:00028946767825/gbbbb2014308,urn:track:universal:00028946767825/gbbbb2014309,urn:track:universal:00028946767825/gbbbb2014310,urn:track:universal:00028946767825/gbbbb2014311,urn:track:universal:00028946767825/gbbbb2014312,urn:track:universal:00028946767825/gbbbb2014313,urn:track:universal:00028946767825/gbbbb2014314,urn:track:universal:00028946767825/gbbbb2014315,urn:track:universal:00028946767825/gbbbb2014316,urn:track:universal:00028946767825/gbbbb2014317,urn:track:universal:00028946767825/gbbbb2014318,urn:track:universal:00028946767825/gbbbb2014319,urn:track:universal:00028946767825/gbbbb2014320,urn:track:universal:00028946767825/gbbbb2014321,urn:track:universal:00028946767825/gbbbb2014322,urn:track:universal:00028946767825/gbbbb2014323]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TP}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},Labels:[{ExternalRef:deccamusicgroupltd,ExternalUrn:urn:label:universal:deccamusicgroupltd,SupplierKeyName:universal,Name:Decca Music Group Ltd.},{ExternalRef:decca,ExternalUrn:urn:label:universal:decca,SupplierKeyName:universal,Name:Decca}],Artists:[{ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra,SupplierKeyName:universal,Name:""Orchestra [Orchestra]""},{ExternalRef:nickingmanconductor,ExternalUrn:urn:artist:universal:nickingmanconductor,SupplierKeyName:universal,Name:""Nick Ingman [Conductor]""},{ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor,SupplierKeyName:universal,Name:""Nick Ingham [Conductor]""},{ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble,SupplierKeyName:universal,Name:""La Scala [Ensemble]""},{ExternalRef:nucciosianovocalist,ExternalUrn:urn:artist:universal:nucciosianovocalist,SupplierKeyName:universal,Name:""Nuccio Siano [Vocalist]""},{ExternalRef:enricocarusotenor,ExternalUrn:urn:artist:universal:enricocarusotenor,SupplierKeyName:universal,Name:""Enrico Caruso [Tenor]""},{ExternalRef:russellwatsontenor,ExternalUrn:urn:artist:universal:russellwatsontenor,SupplierKeyName:universal,Name:""Russell Watson [Tenor]""}],Tracks:[{Delete:False,ExternalRef:00028946767825/gbbbb2014301,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014301,SupplierKeyName:universal,Name:""Pelagia's Song [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Pelagia's Song,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014301,DiscNumber:1,TrackNumber:1,DurationMs:251000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c/00028946767825/gbbbb2014301/ogg/160/251000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c/00028946767825/gbbbb2014301/mp3/320/251000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014302,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014302,SupplierKeyName:universal,Name:""The Recruiting Officer [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Recruiting Officer,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014302,DiscNumber:1,TrackNumber:2,DurationMs:90000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb/00028946767825/gbbbb2014302/ogg/160/90000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb/00028946767825/gbbbb2014302/mp3/320/90000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014303,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014303,SupplierKeyName:universal,Name:""To Albania [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:To Albania,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014303,DiscNumber:1,TrackNumber:3,DurationMs:121000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f/00028946767825/gbbbb2014303/ogg/160/121000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f/00028946767825/gbbbb2014303/mp3/320/121000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014304,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014304,SupplierKeyName:universal,Name:""Horgota Beach [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Horgota Beach,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014304,DiscNumber:1,TrackNumber:4,DurationMs:110000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8/00028946767825/gbbbb2014304/ogg/160/110000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8/00028946767825/gbbbb2014304/mp3/320/110000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014305,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014305,SupplierKeyName:universal,Name:""Albania [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Albania,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014305,DiscNumber:1,TrackNumber:5,DurationMs:128000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a/00028946767825/gbbbb2014305/ogg/160/128000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a/00028946767825/gbbbb2014305/mp3/320/128000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014306,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014306,SupplierKeyName:universal,Name:""The Arrival of the Italians [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Arrival of the Italians,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014306,DiscNumber:1,TrackNumber:6,DurationMs:155000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db/00028946767825/gbbbb2014306/ogg/160/155000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db/00028946767825/gbbbb2014306/mp3/320/155000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014307,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014307,SupplierKeyName:universal,Name:""Act 3 [Rigoletto} - Lili Marlene"",NameExVersion:""Act 3 [Rigoletto} - Lili Marlene"",LabelText:Decca,ArtistText:""La Scala [Ensemble]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014307,DiscNumber:1,TrackNumber:7,DurationMs:188000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""La Scala [Ensemble]"",Role:Main Artist,ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble},{Name:""Nuccio Siano [Vocalist]"",Role:Artist,ExternalRef:nucciosianovocalist,ExternalUrn:urn:artist:universal:nucciosianovocalist},{Name:""Nuccio Siano [Vocalist]"",Role:Performer,ExternalRef:nucciosianovocalist,ExternalUrn:urn:artist:universal:nucciosianovocalist},{Name:""Verdi, Giuseppe [Composer]"",Role:Composer,ExternalRef:verdigiuseppecomposer,ExternalUrn:urn:artist:universal:verdigiuseppecomposer},{Name:""Piave, Francesco Maria [Author]"",Role:Composer,ExternalRef:piavefrancescomariaauthor,ExternalUrn:urn:artist:universal:piavefrancescomariaauthor},{Name:Verdi,ExternalRef:verdi,ExternalUrn:urn:artist:universal:verdi},{Name:""La Scala [Ensemble]"",Role:Orchestra,ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:lascalaensemble,urn:artist:universal:nucciosianovocalist]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/ogg/160/188000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/mp3/320/188000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014308,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014308,SupplierKeyName:universal,Name:""The Tango [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Tango,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014308,DiscNumber:1,TrackNumber:8,DurationMs:134000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e/00028946767825/gbbbb2014308/ogg/160/134000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e/00028946767825/gbbbb2014308/mp3/320/134000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014309,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014309,SupplierKeyName:universal,Name:Santa Lucia,NameExVersion:Santa Lucia,LabelText:Decca,ArtistText:""Enrico Caruso [Tenor]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014309,DiscNumber:1,TrackNumber:9,DurationMs:204000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Enrico Caruso [Tenor]"",Role:Main Artist,ExternalRef:enricocarusotenor,ExternalUrn:urn:artist:universal:enricocarusotenor},{Name:""La Scala [Ensemble]"",Role:Artist,ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble},{Name:""Enrico Caruso [Tenor]"",Role:Performer,ExternalRef:enricocarusotenor,ExternalUrn:urn:artist:universal:enricocarusotenor},{Name:""Cottrau, Teodoro [Composer]"",Role:Composer,ExternalRef:cottrauteodorocomposer,ExternalUrn:urn:artist:universal:cottrauteodorocomposer},{Name:""Cossovich, J. [Author]"",Role:Composer,ExternalRef:cossovichjauthor,ExternalUrn:urn:artist:universal:cossovichjauthor},{Name:Cottrau,ExternalRef:cottrau,ExternalUrn:urn:artist:universal:cottrau},{Name:""La Scala [Ensemble]"",Role:Orchestra,ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:enricocarusotenor,urn:artist:universal:lascalaensemble]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c/00028946767825/gbbbb2014309/ogg/160/204000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c/00028946767825/gbbbb2014309/mp3/320/204000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014310,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014310,SupplierKeyName:universal,Name:""The Mandolin [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Mandolin,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014310,DiscNumber:1,TrackNumber:10,DurationMs:108000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1/00028946767825/gbbbb2014310/ogg/160/108000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1/00028946767825/gbbbb2014310/mp3/320/108000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014311,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014311,SupplierKeyName:universal,Name:""After the Dance [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:After the Dance,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014311,DiscNumber:1,TrackNumber:11,DurationMs:135000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb/00028946767825/gbbbb2014311/ogg/160/135000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb/00028946767825/gbbbb2014311/mp3/320/135000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014312,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014312,SupplierKeyName:universal,Name:""Agii Fanentes [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Agii Fanentes,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014312,DiscNumber:1,TrackNumber:12,DurationMs:95000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4/00028946767825/gbbbb2014312/ogg/160/95000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4/00028946767825/gbbbb2014312/mp3/320/95000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014313,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014313,SupplierKeyName:universal,Name:""Lemoni [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Lemoni,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014313,DiscNumber:1,TrackNumber:13,DurationMs:85000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7/00028946767825/gbbbb2014313/ogg/160/85000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7/00028946767825/gbbbb2014313/mp3/320/85000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014314,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014314,SupplierKeyName:universal,Name:""The Guitar [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Guitar,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014314,DiscNumber:1,TrackNumber:14,DurationMs:105000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8/00028946767825/gbbbb2014314/ogg/160/105000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8/00028946767825/gbbbb2014314/mp3/320/105000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014315,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014315,SupplierKeyName:universal,Name:""Surrender [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Surrender,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014315,DiscNumber:1,TrackNumber:15,DurationMs:136000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7/00028946767825/gbbbb2014315/ogg/160/136000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7/00028946767825/gbbbb2014315/mp3/320/136000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014316,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014316,SupplierKeyName:universal,Name:""On the Jetty [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:On the Jetty,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014316,DiscNumber:1,TrackNumber:16,DurationMs:127000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d/00028946767825/gbbbb2014316/ogg/160/127000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d/00028946767825/gbbbb2014316/mp3/320/127000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014317,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014317,SupplierKeyName:universal,Name:""The Battle [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Battle,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014317,DiscNumber:1,TrackNumber:17,DurationMs:183000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf/00028946767825/gbbbb2014317/ogg/160/183000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf/00028946767825/gbbbb2014317/mp3/320/183000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014318,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014318,SupplierKeyName:universal,Name:""Senza di te [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Senza di te,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Russell Watson [Tenor]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014318,DiscNumber:1,TrackNumber:18,DurationMs:181000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Russell Watson [Tenor]"",Role:Main Artist,ExternalRef:russellwatsontenor,ExternalUrn:urn:artist:universal:russellwatsontenor},{Name:""Russell Watson [Tenor]"",Role:Performer,ExternalRef:russellwatsontenor,ExternalUrn:urn:artist:universal:russellwatsontenor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:russellwatsontenor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50/00028946767825/gbbbb2014318/ogg/160/181000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50/00028946767825/gbbbb2014318/mp3/320/181000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014319,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014319,SupplierKeyName:universal,Name:""Escape from the Island [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Escape from the Island,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014319,DiscNumber:1,TrackNumber:19,DurationMs:103000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f/00028946767825/gbbbb2014319/ogg/160/103000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f/00028946767825/gbbbb2014319/mp3/320/103000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014320,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014320,SupplierKeyName:universal,Name:""The Aftermath [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:The Aftermath,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014320,DiscNumber:1,TrackNumber:20,DurationMs:407000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d/00028946767825/gbbbb2014320/ogg/160/407000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d/00028946767825/gbbbb2014320/mp3/320/407000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014321,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014321,SupplierKeyName:universal,Name:""Iannis' Letter [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Iannis' Letter,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014321,DiscNumber:1,TrackNumber:21,DurationMs:97000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT2C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94/00028946767825/gbbbb2014321/ogg/160/97000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94/00028946767825/gbbbb2014321/mp3/320/97000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014322,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014322,SupplierKeyName:universal,Name:""Ricordo Ancor (Pelagia's Song) [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Ricordo Ancor (Pelagia's Song),NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Russell Watson [Tenor]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014322,DiscNumber:1,TrackNumber:22,DurationMs:225000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Russell Watson [Tenor]"",Role:Main Artist,ExternalRef:russellwatsontenor,ExternalUrn:urn:artist:universal:russellwatsontenor},{Name:""Russell Watson [Tenor]"",Role:Performer,ExternalRef:russellwatsontenor,ExternalUrn:urn:artist:universal:russellwatsontenor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:russellwatsontenor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e/00028946767825/gbbbb2014322/ogg/160/225000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e/00028946767825/gbbbb2014322/mp3/320/225000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]},{Delete:False,ExternalRef:00028946767825/gbbbb2014323,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014323,SupplierKeyName:universal,Name:""Reunion [Captain Corelli's Mandolin - Original Motion Picture Soundtrack]"",NameExVersion:Reunion,NameVersion:Captain Corelli's Mandolin - Original Motion Picture Soundtrack,LabelText:Decca,ArtistText:""Orchestra [Orchestra]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014323,DiscNumber:1,TrackNumber:23,DurationMs:226000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""Orchestra [Orchestra]"",Role:Main Artist,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra},{Name:""Nick Ingham [Conductor]"",Role:Artist,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Nick Ingham [Conductor]"",Role:Conductor,ExternalRef:nickinghamconductor,ExternalUrn:urn:artist:universal:nickinghamconductor},{Name:""Warbeck, Stephen [Composer]"",Role:Composer,ExternalRef:warbeckstephencomposer,ExternalUrn:urn:artist:universal:warbeckstephencomposer},{Name:Warbeck,ExternalRef:warbeck,ExternalUrn:urn:artist:universal:warbeck},{Name:""Orchestra [Orchestra]"",Role:Orchestra,ExternalRef:orchestraorchestra,ExternalUrn:urn:artist:universal:orchestraorchestra}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:orchestraorchestra,urn:artist:universal:nickinghamconductor]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788/00028946767825/gbbbb2014323/ogg/160/226000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788/00028946767825/gbbbb2014323/mp3/320/226000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]}],Assets:[{ExternalRef:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4,SupplierKeyName:universal,AssetType:MasterCoverArt,ExternalOwnerUrn:urn:album:universal:00028946767825,FileName:UMG_cvrart_00028946767825_01_RGB300_800x793_1257915.jpg,FileExtension:jpg,FileSizeBytes:77661,MasterSha256Checksum:3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4,Width:793,Height:800,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_cvrart_00028946767825_01_RGB300_800x793_1257915.jpg},{ExternalRef:trackpreview/ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c/00028946767825/gbbbb2014301/ogg/160/251000,ExternalUrn:urn:asset:universal:trackpreview/ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c/00028946767825/gbbbb2014301/ogg/160/251000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014301,FileName:UMG_audtrk_00028946767825_01_001_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:4624528,MasterSha256Checksum:ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c,DurationMs:251000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_001_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c/00028946767825/gbbbb2014301/mp3/320/251000,ExternalUrn:urn:asset:universal:trackproduct/ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c/00028946767825/gbbbb2014301/mp3/320/251000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014301,FileName:UMG_audtrk_00028946767825_01_001_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:7167050,MasterSha256Checksum:ed7d91022e3ab950bfebe3a29eb6a911d0f543d63e030f9ec56d1bec612a1a6c,DurationMs:251000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_001_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb/00028946767825/gbbbb2014302/ogg/160/90000,ExternalUrn:urn:asset:universal:trackpreview/363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb/00028946767825/gbbbb2014302/ogg/160/90000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014302,FileName:UMG_audtrk_00028946767825_01_002_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1625235,MasterSha256Checksum:363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb,DurationMs:90000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_002_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb/00028946767825/gbbbb2014302/mp3/320/90000,ExternalUrn:urn:asset:universal:trackproduct/363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb/00028946767825/gbbbb2014302/mp3/320/90000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014302,FileName:UMG_audtrk_00028946767825_01_002_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:2687974,MasterSha256Checksum:363d64260615da5bcce091feb3ed15177e6e4a55eab80236075821c42913aecb,DurationMs:90000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_002_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f/00028946767825/gbbbb2014303/ogg/160/121000,ExternalUrn:urn:asset:universal:trackpreview/2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f/00028946767825/gbbbb2014303/ogg/160/121000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014303,FileName:UMG_audtrk_00028946767825_01_003_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2177905,MasterSha256Checksum:2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f,DurationMs:121000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_003_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f/00028946767825/gbbbb2014303/mp3/320/121000,ExternalUrn:urn:asset:universal:trackproduct/2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f/00028946767825/gbbbb2014303/mp3/320/121000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014303,FileName:UMG_audtrk_00028946767825_01_003_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3662748,MasterSha256Checksum:2c0eb2b8c383f9099572e854117f8ad475c1b98c85ab248e67e9e442f925868f,DurationMs:121000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_003_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8/00028946767825/gbbbb2014304/ogg/160/110000,ExternalUrn:urn:asset:universal:trackpreview/341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8/00028946767825/gbbbb2014304/ogg/160/110000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014304,FileName:UMG_audtrk_00028946767825_01_004_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1924641,MasterSha256Checksum:341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8,DurationMs:110000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_004_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8/00028946767825/gbbbb2014304/mp3/320/110000,ExternalUrn:urn:asset:universal:trackproduct/341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8/00028946767825/gbbbb2014304/mp3/320/110000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014304,FileName:UMG_audtrk_00028946767825_01_004_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3111303,MasterSha256Checksum:341b7ebe9260ce938f002b77d68c5b0c0ff1e4910a048d967e3d6efddac15ed8,DurationMs:110000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_004_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a/00028946767825/gbbbb2014305/ogg/160/128000,ExternalUrn:urn:asset:universal:trackpreview/32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a/00028946767825/gbbbb2014305/ogg/160/128000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014305,FileName:UMG_audtrk_00028946767825_01_005_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2316597,MasterSha256Checksum:32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a,DurationMs:128000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_005_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a/00028946767825/gbbbb2014305/mp3/320/128000,ExternalUrn:urn:asset:universal:trackproduct/32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a/00028946767825/gbbbb2014305/mp3/320/128000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014305,FileName:UMG_audtrk_00028946767825_01_005_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3960289,MasterSha256Checksum:32458fb87475d1a7b33580ee00a5dc42379499cdb591252114e3e63b6254e25a,DurationMs:128000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_005_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db/00028946767825/gbbbb2014306/ogg/160/155000,ExternalUrn:urn:asset:universal:trackpreview/86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db/00028946767825/gbbbb2014306/ogg/160/155000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014306,FileName:UMG_audtrk_00028946767825_01_006_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:3055351,MasterSha256Checksum:86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db,DurationMs:155000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_006_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db/00028946767825/gbbbb2014306/mp3/320/155000,ExternalUrn:urn:asset:universal:trackproduct/86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db/00028946767825/gbbbb2014306/mp3/320/155000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014306,FileName:UMG_audtrk_00028946767825_01_006_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:4491772,MasterSha256Checksum:86b0d012918868d914eb0916e26524d174d17be54f1daed66085372c70ecb0db,DurationMs:155000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_006_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/ogg/160/188000,ExternalUrn:urn:asset:universal:trackpreview/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/ogg/160/188000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014307,FileName:UMG_audtrk_00028946767825_01_007_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:3224900,MasterSha256Checksum:9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc,DurationMs:188000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_007_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/mp3/320/188000,ExternalUrn:urn:asset:universal:trackproduct/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/mp3/320/188000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014307,FileName:UMG_audtrk_00028946767825_01_007_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:5469721,MasterSha256Checksum:9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc,DurationMs:188000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_007_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e/00028946767825/gbbbb2014308/ogg/160/134000,ExternalUrn:urn:asset:universal:trackpreview/054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e/00028946767825/gbbbb2014308/ogg/160/134000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014308,FileName:UMG_audtrk_00028946767825_01_008_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2588580,MasterSha256Checksum:054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e,DurationMs:134000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_008_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e/00028946767825/gbbbb2014308/mp3/320/134000,ExternalUrn:urn:asset:universal:trackproduct/054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e/00028946767825/gbbbb2014308/mp3/320/134000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014308,FileName:UMG_audtrk_00028946767825_01_008_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3924455,MasterSha256Checksum:054813892448ba3aa71066c53f36f12caa8cb2a63eb00491718ef6b8c7ad148e,DurationMs:134000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_008_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c/00028946767825/gbbbb2014309/ogg/160/204000,ExternalUrn:urn:asset:universal:trackpreview/1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c/00028946767825/gbbbb2014309/ogg/160/204000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014309,FileName:UMG_audtrk_00028946767825_01_009_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2881331,MasterSha256Checksum:1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c,DurationMs:204000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_009_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c/00028946767825/gbbbb2014309/mp3/320/204000,ExternalUrn:urn:asset:universal:trackproduct/1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c/00028946767825/gbbbb2014309/mp3/320/204000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014309,FileName:UMG_audtrk_00028946767825_01_009_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:5946636,MasterSha256Checksum:1e49670eabb34dfbc193ef939f5f6680edde526cedcab3ea427449922da8434c,DurationMs:204000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_009_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1/00028946767825/gbbbb2014310/ogg/160/108000,ExternalUrn:urn:asset:universal:trackpreview/b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1/00028946767825/gbbbb2014310/ogg/160/108000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014310,FileName:UMG_audtrk_00028946767825_01_010_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2013656,MasterSha256Checksum:b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1,DurationMs:108000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_010_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1/00028946767825/gbbbb2014310/mp3/320/108000,ExternalUrn:urn:asset:universal:trackproduct/b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1/00028946767825/gbbbb2014310/mp3/320/108000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014310,FileName:UMG_audtrk_00028946767825_01_010_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3246169,MasterSha256Checksum:b16af358560813ef02083f5b78957e1c3f0c9c69d50e2990392c2ff5b90c4bc1,DurationMs:108000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_010_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb/00028946767825/gbbbb2014311/ogg/160/135000,ExternalUrn:urn:asset:universal:trackpreview/369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb/00028946767825/gbbbb2014311/ogg/160/135000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014311,FileName:UMG_audtrk_00028946767825_01_011_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2388464,MasterSha256Checksum:369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb,DurationMs:135000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_011_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb/00028946767825/gbbbb2014311/mp3/320/135000,ExternalUrn:urn:asset:universal:trackproduct/369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb/00028946767825/gbbbb2014311/mp3/320/135000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014311,FileName:UMG_audtrk_00028946767825_01_011_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3708865,MasterSha256Checksum:369b6c4a1b1baccf9753fa6987f5ecbbb0d9e85c23cddc3e2a99ef3b96a93dfb,DurationMs:135000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_011_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4/00028946767825/gbbbb2014312/ogg/160/95000,ExternalUrn:urn:asset:universal:trackpreview/6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4/00028946767825/gbbbb2014312/ogg/160/95000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014312,FileName:UMG_audtrk_00028946767825_01_012_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1541218,MasterSha256Checksum:6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4,DurationMs:95000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_012_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4/00028946767825/gbbbb2014312/mp3/320/95000,ExternalUrn:urn:asset:universal:trackproduct/6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4/00028946767825/gbbbb2014312/mp3/320/95000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014312,FileName:UMG_audtrk_00028946767825_01_012_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:2670657,MasterSha256Checksum:6f810026cd9eaeaeb9b6fb3d2478f98503428866aba9bf745ca26de718cd7fe4,DurationMs:95000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_012_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7/00028946767825/gbbbb2014313/ogg/160/85000,ExternalUrn:urn:asset:universal:trackpreview/06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7/00028946767825/gbbbb2014313/ogg/160/85000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014313,FileName:UMG_audtrk_00028946767825_01_013_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1568808,MasterSha256Checksum:06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7,DurationMs:85000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_013_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7/00028946767825/gbbbb2014313/mp3/320/85000,ExternalUrn:urn:asset:universal:trackproduct/06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7/00028946767825/gbbbb2014313/mp3/320/85000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014313,FileName:UMG_audtrk_00028946767825_01_013_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:2447584,MasterSha256Checksum:06f1ae2753d3312d480b046508dea5eac5d1ef2924013ae1c6dda7c1b62910f7,DurationMs:85000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_013_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8/00028946767825/gbbbb2014314/ogg/160/105000,ExternalUrn:urn:asset:universal:trackpreview/cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8/00028946767825/gbbbb2014314/ogg/160/105000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014314,FileName:UMG_audtrk_00028946767825_01_014_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1520184,MasterSha256Checksum:cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8,DurationMs:105000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_014_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8/00028946767825/gbbbb2014314/mp3/320/105000,ExternalUrn:urn:asset:universal:trackproduct/cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8/00028946767825/gbbbb2014314/mp3/320/105000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014314,FileName:UMG_audtrk_00028946767825_01_014_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:2821822,MasterSha256Checksum:cbc8034b4e1ebdf114c3578bc4662b03ec5c4a2418fd95c8c4e13d563100d5e8,DurationMs:105000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_014_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7/00028946767825/gbbbb2014315/ogg/160/136000,ExternalUrn:urn:asset:universal:trackpreview/608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7/00028946767825/gbbbb2014315/ogg/160/136000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014315,FileName:UMG_audtrk_00028946767825_01_015_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2639424,MasterSha256Checksum:608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7,DurationMs:136000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_015_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7/00028946767825/gbbbb2014315/mp3/320/136000,ExternalUrn:urn:asset:universal:trackproduct/608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7/00028946767825/gbbbb2014315/mp3/320/136000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014315,FileName:UMG_audtrk_00028946767825_01_015_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3818998,MasterSha256Checksum:608e17488e8ca29f3eefffe2c54bedc90034399e4ad9a3a433e4f86561d442e7,DurationMs:136000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_015_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d/00028946767825/gbbbb2014316/ogg/160/127000,ExternalUrn:urn:asset:universal:trackpreview/5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d/00028946767825/gbbbb2014316/ogg/160/127000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014316,FileName:UMG_audtrk_00028946767825_01_016_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2164772,MasterSha256Checksum:5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d,DurationMs:127000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_016_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d/00028946767825/gbbbb2014316/mp3/320/127000,ExternalUrn:urn:asset:universal:trackproduct/5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d/00028946767825/gbbbb2014316/mp3/320/127000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014316,FileName:UMG_audtrk_00028946767825_01_016_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3587188,MasterSha256Checksum:5d30fb4ea9227ec9b6082943f4920f70bd711248453f4460e6c4dc90a3ec372d,DurationMs:127000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_016_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf/00028946767825/gbbbb2014317/ogg/160/183000,ExternalUrn:urn:asset:universal:trackpreview/817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf/00028946767825/gbbbb2014317/ogg/160/183000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014317,FileName:UMG_audtrk_00028946767825_01_017_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:3166112,MasterSha256Checksum:817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf,DurationMs:183000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_017_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf/00028946767825/gbbbb2014317/mp3/320/183000,ExternalUrn:urn:asset:universal:trackproduct/817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf/00028946767825/gbbbb2014317/mp3/320/183000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014317,FileName:UMG_audtrk_00028946767825_01_017_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:5236906,MasterSha256Checksum:817623ce54055365022077593f42e1daf69a682f3d80d7f868e429e6e73e0bbf,DurationMs:183000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_017_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50/00028946767825/gbbbb2014318/ogg/160/181000,ExternalUrn:urn:asset:universal:trackpreview/220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50/00028946767825/gbbbb2014318/ogg/160/181000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014318,FileName:UMG_audtrk_00028946767825_01_018_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:2983432,MasterSha256Checksum:220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50,DurationMs:181000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_018_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50/00028946767825/gbbbb2014318/mp3/320/181000,ExternalUrn:urn:asset:universal:trackproduct/220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50/00028946767825/gbbbb2014318/mp3/320/181000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014318,FileName:UMG_audtrk_00028946767825_01_018_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:5081258,MasterSha256Checksum:220c7d1e376121620238b34693088e9c665fbac4956ea35cb0ca95001c99ed50,DurationMs:181000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_018_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f/00028946767825/gbbbb2014319/ogg/160/103000,ExternalUrn:urn:asset:universal:trackpreview/ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f/00028946767825/gbbbb2014319/ogg/160/103000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014319,FileName:UMG_audtrk_00028946767825_01_019_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1761498,MasterSha256Checksum:ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f,DurationMs:103000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_019_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f/00028946767825/gbbbb2014319/mp3/320/103000,ExternalUrn:urn:asset:universal:trackproduct/ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f/00028946767825/gbbbb2014319/mp3/320/103000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014319,FileName:UMG_audtrk_00028946767825_01_019_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:3092185,MasterSha256Checksum:ea7b1658d8503b553e8ef1caca41e544275338c27bf86079101278046e32ed1f,DurationMs:103000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_019_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d/00028946767825/gbbbb2014320/ogg/160/407000,ExternalUrn:urn:asset:universal:trackpreview/e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d/00028946767825/gbbbb2014320/ogg/160/407000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014320,FileName:UMG_audtrk_00028946767825_01_020_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:7343705,MasterSha256Checksum:e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d,DurationMs:407000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_020_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d/00028946767825/gbbbb2014320/mp3/320/407000,ExternalUrn:urn:asset:universal:trackproduct/e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d/00028946767825/gbbbb2014320/mp3/320/407000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014320,FileName:UMG_audtrk_00028946767825_01_020_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:11912335,MasterSha256Checksum:e37547579793faf5d81db478ffc83c2df9f4ba479d69c6e3566a5fbc1abbad5d,DurationMs:407000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_020_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94/00028946767825/gbbbb2014321/ogg/160/97000,ExternalUrn:urn:asset:universal:trackpreview/9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94/00028946767825/gbbbb2014321/ogg/160/97000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014321,FileName:UMG_audtrk_00028946767825_01_021_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:1643495,MasterSha256Checksum:9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94,DurationMs:97000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_021_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94/00028946767825/gbbbb2014321/mp3/320/97000,ExternalUrn:urn:asset:universal:trackproduct/9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94/00028946767825/gbbbb2014321/mp3/320/97000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014321,FileName:UMG_audtrk_00028946767825_01_021_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:2674597,MasterSha256Checksum:9a3d948a640fbebf5700699aab34cf2f6709f20042c63a6580a99b7a3b67ab94,DurationMs:97000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_021_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e/00028946767825/gbbbb2014322/ogg/160/225000,ExternalUrn:urn:asset:universal:trackpreview/80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e/00028946767825/gbbbb2014322/ogg/160/225000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014322,FileName:UMG_audtrk_00028946767825_01_022_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:3970352,MasterSha256Checksum:80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e,DurationMs:225000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_022_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e/00028946767825/gbbbb2014322/mp3/320/225000,ExternalUrn:urn:asset:universal:trackproduct/80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e/00028946767825/gbbbb2014322/mp3/320/225000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014322,FileName:UMG_audtrk_00028946767825_01_022_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:6397747,MasterSha256Checksum:80f169143230bd5f69282b98a4f1d176883c33776e42a3510a09d2082057548e,DurationMs:225000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_022_16.flac.mflow_320.mp3},{ExternalRef:trackpreview/56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788/00028946767825/gbbbb2014323/ogg/160/226000,ExternalUrn:urn:asset:universal:trackpreview/56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788/00028946767825/gbbbb2014323/ogg/160/226000,SupplierKeyName:universal,AssetType:TrackPreview,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014323,FileName:UMG_audtrk_00028946767825_01_023_16.flac.mflow_160.ogg,FileExtension:ogg,FileSizeBytes:4244125,MasterSha256Checksum:56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788,DurationMs:226000,BitRateKbps:160,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_023_16.flac.mflow_160.ogg},{ExternalRef:trackproduct/56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788/00028946767825/gbbbb2014323/mp3/320/226000,ExternalUrn:urn:asset:universal:trackproduct/56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788/00028946767825/gbbbb2014323/mp3/320/226000,SupplierKeyName:universal,AssetType:TrackProduct,ExternalOwnerUrn:urn:track:universal:00028946767825/gbbbb2014323,FileName:UMG_audtrk_00028946767825_01_023_16.flac.mflow_320.mp3,FileExtension:mp3,FileSizeBytes:6409539,MasterSha256Checksum:56b82ef9e60ae760e60d56f5c9dde28ccb5ea916c0663271b2e6a22f27e63788,DurationMs:226000,BitRateKbps:320,TranscodedAssetPath:transcoded-i:///universal/2000000916259/00028946767825_2000000916259/UMG_audtrk_00028946767825_01_023_16.flac.mflow_320.mp3}]}";
			var dto = TypeSerializer.DeserializeFromString<ReleaseChangeSet>(dtoString);
		}

		[Test]
		public void Can_serialize_TrackUpdate_string()
		{
			const string dtoString = @"{Delete:False,ExternalRef:00028946767825/gbbbb2014307,ExternalUrn:urn:track:universal:00028946767825/gbbbb2014307,SupplierKeyName:universal,Name:""Act 3 [Rigoletto} - Lili Marlene"",NameExVersion:""Act 3 [Rigoletto} - Lili Marlene"",LabelText:Decca,ArtistText:""La Scala [Ensemble]"",ReleaseText:Captain Corelli's Mandolin -Original Motion Picture Soundtrack,Isrc:GBBBB2014307,DiscNumber:1,TrackNumber:7,DurationMs:188000,ExplicitType:Unknown,Copyright:2001 Decca Music Group Limited,Genres:[Classical],Participants:[{Name:""La Scala [Ensemble]"",Role:Main Artist,ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble},{Name:""Nuccio Siano [Vocalist]"",Role:Artist,ExternalRef:nucciosianovocalist,ExternalUrn:urn:artist:universal:nucciosianovocalist},{Name:""Nuccio Siano [Vocalist]"",Role:Performer,ExternalRef:nucciosianovocalist,ExternalUrn:urn:artist:universal:nucciosianovocalist},{Name:""Verdi, Giuseppe [Composer]"",Role:Composer,ExternalRef:verdigiuseppecomposer,ExternalUrn:urn:artist:universal:verdigiuseppecomposer},{Name:""Piave, Francesco Maria [Author]"",Role:Composer,ExternalRef:piavefrancescomariaauthor,ExternalUrn:urn:artist:universal:piavefrancescomariaauthor},{Name:Verdi,ExternalRef:verdi,ExternalUrn:urn:artist:universal:verdi},{Name:""La Scala [Ensemble]"",Role:Orchestra,ExternalRef:lascalaensemble,ExternalUrn:urn:artist:universal:lascalaensemble}],ExternalLabelUrn:urn:label:universal:decca,ExternalReleaseUrn:urn:album:universal:00028946767825,ExternalArtistUrns:{Partial:False,Items:[urn:artist:universal:lascalaensemble,urn:artist:universal:nucciosianovocalist]},Products:{Partial:False,Items:[{Delete:False,TerritoryCode:GB,Copyright:2001 Decca Music Group Limited,AllowDownload:True,AllowStreaming:True,AllowSubscription:False,CollectionOnly:False,DownloadStartDate:2010-01-08,CostPoints:[{StartDate:2010-01-08,CostCode:TCT7C}],StreamingStartDate:2010-01-08}]},AssetIds:[{AssetType:TrackPreview,ExternalUrn:urn:asset:universal:trackpreview/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/ogg/160/188000},{AssetType:TrackProduct,ExternalUrn:urn:asset:universal:trackproduct/9e93fe68d2aa1aa6b3231a03c07cfb25f6b7fcd15b1e520aee6d4f27919aa5cc/00028946767825/gbbbb2014307/mp3/320/188000},{AssetType:MasterCoverArt,ExternalUrn:urn:asset:universal:mastercoverart/3ba1732101be3375835f24b1fbabf6eee75f0eef2573cc83398035fce31b46f4}]}";
			var toDto = TypeSerializer.DeserializeFromString<ReleaseChangeSet>(dtoString);
		}

		[Test]
		public void Can_serialize_TrackUpdate()
		{
			var dto = new TrackUpdate {
				Delete = false,
				ExternalRef = "00028946767825/gbbbb2014307",
				ExternalUrn = "urn:track:universal:00028946767825/gbbbb2014307",
				SupplierKeyName = "universal",
				Name = "Act 3 [Rigoletto} - Lili Marlene",
				NameExVersion = "Act 3 [Rigoletto} - Lili Marlene",
				LabelText = "Decca",
				ArtistText = "La Scala [Ensemble]",
				ReleaseText = "Captain Corelli's Mandolin -Original Motion Picture Soundtrack",
				Isrc = "GBBBB2014307",
				DiscNumber = 1,
				TrackNumber=7,
				DurationMs = 188000,
				ExplicitType = ExplicitType.Unknown,
				Copyright = "Copyright:2001 Decca Music Group Limited",
				Genres = new List<string> { "Classical" },
			};

			Serialize(dto);
		}

	}
}